{-------------------------------------------------------------------------------

                 Tri d'un DBGrid reli un TQuery

 Exemple ralis avec Delphi 7 Entreprise
 
 Composants : TQuery, TDataSource, TDbgrid , TToolbar, TStatusBar
 Alias : DBDemos et la table country
 Cet exemple permet de tri en ordre croissant ou dcroissant un DBGRID en
 cliquant sur l'entte de la colone.

Pour commencer:
 Dposez un TBgrid sur la form
  -rglage des proprits
      align = alClient
      Datasource = datasource1
      Name = DbGrid1
 Dposez TQuery sur la form
  -rglage des proprits
     DatabaseName = DBDemos
     Name = Query1
     SQL = select * from country order by 1 ASC

 Dposez un TdataSource sur la form
   -Rglage des proprits
       Name = datasource1
       Dataset = Query1

 maintenant slectionnez le TDbGrid sur la page vnement de l'inspecteur
 d'object double-cliquez sur l'vnement OnTitleClick pour gnrer le
 squelette de la procedure  c'est la que tout va se jouer.

pour aller plus loin:  Dessiner sur l'entte de colone le sens du tri.

Commentaires, sugestions, critiques  : julienraine@laetjr.com

-------------------------------------------------------------------------------}
unit U_main;

interface

uses
  Windows, Messages, SysUtils,  Classes, Graphics, Controls, Forms,
  Dialogs, DB, Grids, DBGrids, DBTables, ComCtrls, ToolWin;

type
  TForm1 = class(TForm)
    Query1: TQuery;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    StatusBar1: TStatusBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    procedure DBGrid1TitleClick(Column: TColumn);
    procedure FormCreate(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Dclarations prives }
    fsensTri: integer;
    function GetColname: string;
    Function GetSensTri(S: string): integer;
  public
    { Dclarations publiques }
    property Senstri : integer read fsensTri write fsensTri default 0;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
{ ******************************************************************************
 Variables:
     StrSql : contient la requte avec le tri acsendant
     StrsqlDesc : contient la requte avec le tri descendant
     StrFieldname : Contient le nom du champ qui servira au tri
     StrFields : Contient l'ensemble des noms des champs de la requte

     SensTri : 0 = Tri descendant
               -1 ou 1 = Tri ascendant
Note:
 Pour cet exemple nous avons pris deux variables une pour le tri ascendant et
 l'autre pour le tri descendant mais une seule suffirait.

Rappel : en SQl le tri se fait avec la clause
   ORDER BY CHAMP1 [ASC,DESC], CHAMP2 [ASC,DESC], CHAMP_x [ASC,DESC]

******************************************************************************}
procedure TForm1.DBGrid1TitleClick(Column: TColumn);
var StrSql, StrFieldName, StrFields, StrSqlDesc : string ;
begin
{ Si le type des donnes sous jacent est de type chaine, entier, valeur relle
  alors on peut faire le tri,
}
    if Column.Field.DataType in [ftString, ftInteger, ftFloat] then begin
       strsql :=  'select %s from country order by %s ASC';
       StrSqlDesc := 'Select %s from country order by %s DESC';
       {on rcupre l'ensemble des noms des diffrents champs car plus rapide
        qu'un select *
       }
       StrFields := GetColname;
       {On recupre le nom du champ qui participera au tri clause order by CHAMP
       }
       StrFieldName := Column.FieldName ;
       with Query1 do begin
         Close;                           // fermeture
         SensTri := GetSensTri(Sql.Text); // sens de tri actuel
         SQL.Clear;                       // suppression du texte de la requete
         {suivant le sens de tri actuel on va inverser le tri}
           case sensTri of
             0 : Sql.Text := Format(StrSqlDesc,[strFields,StrFieldname]);
             -1,1 :SQL.Text := Format(strSql,[strFields,StrFieldName]);
           end; //case
         Open;
         StatusBar1.SimpleText := Copy(Sql.Text,1,length(Sql.Text)-2);
         DbGrid1.Hint := StatusBar1.SimpleText;
       end;// width
    end;// if
end;
//------------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
   SensTri := 1;
   if not Query1.Active then
    Query1.Open;
end;
//------------------------------------------------------------------------------
function TForm1.GetColname: string;
var i : integer;
begin
    For i := 0 to DBGrid1.Columns.Count -1 do
     Result := Result + DBGrid1.Columns[i].FieldName +','+#32;
    if Result <> emptyStr then
     Result := Copy(Result,1,length(Result)-2);
end;
//------------------------------------------------------------------------------
function TForm1.GetSensTri(S: string): integer;
var i,j : integer;
begin
    Result := -1;
    i := pos('ASC',s) ; J := pos('DESC',s);
    if i > 0 then begin
     Result := 0;
     Exit;
    end;
    if J > 0 then begin
     Result := 1;
     exit;
    end;
end;
//------------------------------------------------------------------------------
procedure TForm1.ToolButton1Click(Sender: TObject);
begin
    Close;
end;
//------------------------------------------------------------------------------
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    If query1.Active then
     Query1.Close;
end;
//------------------------------------------------------------------------------
end.
